#!/usr/bin/perl
# Datei: complex.pm
# Klasse zur Bearbeitung komplexer Zahlen
package complex;
# ***
# Konstruktor
# ***
sub new{
	my($class, $re, $im)=@_;
	my $self={};
	bless $self, $class;
	$self->{re}=$re;	# Realteil der komplexen Zahl
	$self->{im}=$im;	# Imaginaerteil der komplexen Zahl
	return( $self );
}
# ***
# Addition zweier komplexer Zahlen
# ***
sub add{
	my($self, $op2)=@_;
	my($result);		# Referenz auf Ergebnisobjekt

$result=complex->new(			$self->{re} + $op2->{re},
					$self->{im} + $op2->{im}
			  );
	return( $result );
}
# ***
# Betragsbildung
# ***
sub abs{
	my $self=shift;
	# Schreibvereinfachung:
	my ($re, $im) = ( $self->{re}, $self->{im} );

	# Berechnung des Betrags aus Real- und Imaginaerteil
	return( sqrt($re**2 + $im**2) );
}
# ***
# Ausgabe einer komplexen Zahl
# ***
sub print{
	my $self=shift;
	# Schreibvereinfachung:
	my ($re, $im) = ( $self->{re}, $self->{im} );
	print "$re+$im i \n";
}
# Liefere OK als Ergebnis dieses Moduls
1;
